/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2008-2011 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: core_insn.h 2178 2011-07-23 09:58:56Z ertl-honda $
 */


/*
 *  RAˑ̓ꖽ߂̃CC֐`iARM-Mpj
 */

#ifndef CORE_INSN_H
#define CORE_INSN_H

#include <arm_m.h>

/*
 *  ύX邱ƂRpCɓ`邽߂̃}N
 */
#define ARM_MEMORY_CHANGED __memory_changed()

/*
 *  FAULTMASK̃Zbg
 */
Inline void
set_faultmask(void){
	__disable_fiq();
}

/*
 *  FAULTMASK̃NA
 */
Inline void
clear_faultmask(void){
	__enable_fiq();
}

/*
 *  PRIMASK̃Zbg
 */
Inline void
set_primask(void){
	__disable_irq();
}

/*
 *  PRIMASK̃NA
 */
Inline void
clear_primask(void){
	__enable_irq();
}

/*
 *  BASEPRĨZbg
 */
Inline void
set_basepri(uint32_t val){
	register uint32_t basepri __asm("basepri");
	basepri = val;
}

/*
 *  BASEPRI̎擾
 */
Inline uint32_t
get_basepri(void){
	register uint32_t basepri __asm("basepri");
	return basepri;
}

/*
 *  CONTROL̃Zbg
 */
Inline void
set_control(uint32_t val){
	register uint32_t control __asm("control");
	control = val;
	/*
	 *  controlWX^ZbgɂisbK{
	 *  [ARMv7-M Architecture Reference Manaual(DDI0403B) A3-37]
	 */
	__isb(0xf);
}

/*
 *  CONTROL̎擾
 */
Inline uint32_t
get_control(void){
	register uint32_t control __asm("control");
	return(control);
}

/*
 *  Xe[^XWX^iIPSRǰݒl̓Ǐo
 */
Inline uint32_t
get_ipsr(void)
{
	register uint32_t ipsr __asm("ipsr");
	return(ipsr);
}

#endif /* CORE_INSN_H */
