/*
 *	TOPPERS/ASP Kernel
 *		Toyohashi Open Platform for Embedded Real-Time Systems/
 *		Advanced Standard Profile Kernel
 *	
 *	Copyright (C) 2007 by Embedded and Real-Time Systems Laboratory
 *				Graduate School of Information Science, Nagoya Univ., JAPAN
 *	Copyright (C) 2007-2010 by Industrial Technology Institute,
 *								Miyagi Prefectural Government, JAPAN
 *	
 *	嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *	ܥեȥѤΤޤࡥʲƱˤѡʣ
 *	ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *	(1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *		ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *		˴ޤޤƤ뤳ȡ
 *	(2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *		ѤǤǺۤˤϡۤȼɥȡ
 *		ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *		̵ݾڵǺܤ뤳ȡ
 *	(3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *		ѤǤʤǺۤˤϡΤ줫ξ
 *		ȡ
 *	  (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *		  ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *	  (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *		  𤹤뤳ȡ
 *	(4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *		⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *		ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *		ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *		դ뤳ȡ
 *	
 *	ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *	TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *	ФŬޤơʤݾڤԤʤޤܥեȥ
 *	ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *	Ǥʤ
 *	
 *	$Id: target_config.c 2142 2011-06-27 07:24:40Z mit-kimai $
 */

/*
 *	åȰ¸⥸塼CQ_FRK_SH2Aѡ
 */

#include "kernel_impl.h"
#include <sil.h>
#include "pdic/sh/sh_scif.h"
#include "cq_frk_sh2a.h"

/*
 *	åȰ¸ν
 */
void
target_initialize(void)
{
	/*
	 *	ץå¸ν
	 */
	prc_initialize();

	/*
	 *	LED³ݡȤν
	 */
	sil_wrh_mem((void *)PCIOR0, sil_reh_mem((void *)PCIOR0) | 0x0100U);
	sil_wrh_mem((void *)PCCR2, sil_reh_mem((void *)PCCR2) & ~0x0003U);
	
	/*
	 *	SCIF2I/OݡȤ
	 */
	sil_wrh_mem((void *)PFCR0, ((sil_reh_mem((void *)PFCR0) & ~0x0ff0) | 0x0440U));	/* SCIF2 -TR- */
	
	/*
	 * СʡѤΥꥢ륳ȥν
	 */
	sh_scif_init(TARGET_PUTC_PORTID);
}

/*
 *	åȰ¸νλ
 */
void
target_exit(void)
{
	/*
	 *	ץå¸νλ
	 */
	prc_exit();

	/*
	 *	ȯĶ¸νλ
	 */
	cq_frk_sh2a_exit();

	/*
	 * ˤʤ
	 */
	while(1);
}


/*
 *   ƥʸλ
 */
#ifndef TOPPERS_HEW_SIMULATOR

#define TARGET_PUT_CHAR(c)	sh_scif_pol_putc(c, TARGET_PUTC_PORTID)

#else	/* TOPPERS_HEW_SIMULATOR */

extern void hew_io_sim_putc(char_t c);
#define TARGET_PUT_CHAR(c)	hew_io_sim_putc(c)

/*  ǽ  */
#define GETC	0x01210000
#define PUTC	0x01220000

/*
 *   HEWI/Oߥ졼ǽƤӽФ
 */
void hew_io_sim(uint32_t code, void *adr);

void hew_io_sim_putc(char_t c)
{
	uint8_t buf = (uint8_t)c;		/*  Хåե  */
	uint8_t *parmblk = &buf;		/*  ѥ᡼֥å  */
	uint8_t **p = &parmblk;			/*  Ƭɥ쥹  */
	uint32_t code = PUTC;			/*  ǽ  */
	
	hew_io_sim(code, p);
}

extern bool_t hew_io_sim_snd_chr(char_t c);

bool_t hew_io_sim_snd_chr(char_t c)
{
	hew_io_sim_putc(c);
	return true;
}

extern int_t hew_io_sim_rcv_chr(void);

int_t hew_io_sim_rcv_chr(void) {
	uint8_t buf;					/*  Хåե  */
	uint8_t *parmblk = &buf;		/*  ѥ᡼֥å  */
	uint8_t **p = &parmblk;			/*  Ƭɥ쥹  */
	uint32_t code = GETC;			/*  ǽ  */
	
	hew_io_sim(code, p);
	return(buf);
}

#endif /* TOPPERS_HEW_SIMULATOR */

/*
 *	ƥ٥ϤΤʸ
 */
void
target_fput_log(char_t c)
{
	if (c == '\n') {
		TARGET_PUT_CHAR('\r');
	}
	TARGET_PUT_CHAR(c);
}
