/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2011 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 */

/*
 * ^[QbgˑW[iSTBEEpj
 */
#include "kernel_impl.h"
#include <sil.h>
#include "stbee.h"
#include "stm32f.h"
#include "usart.h"

/*
 * ^[Qbgˑ@
 */
void
target_initialize(void)
{
	/*
	 *  vZbTNbN(RCC)̏
	 */
	/* HSI̗L */
	sil_orw((void*)RCC_CR, CR_HSI_ON);

	/* SW, HPRE, PPRE1, PPRE2, ADCPRE,MCÕNA */
	sil_andw((void*)RCC_CFGR, 0xF8FF0000);

	/* HSEON, CSSON, PLLON ̃NA */
	sil_andw((void*)RCC_CR, 0xFEF6FFFF);

	/* HSEBYP ̃NA */
	sil_andw((void*)RCC_CR, 0xFFFBFFFF);

	/* PLLSRC, PLLXTPRE, PLLMUL, USBPRE/OTGFSPRE ̃NA */
	sil_andw((void*)RCC_CFGR, 0xFF80FFFF);

	/*
	 *  72Mhzɐݒ
	 */
	/* HSE̗L */
	sil_orw((void*)RCC_CR, CR_HSE_ON);

	/* HSEL҂ */
	while ((sil_rew_mem((void*)RCC_CR) & CR_HSE_RDY) == 0) ;

	/* FLASH ROM̃vtFb`obt@L */
	sil_orw((void*)FLASH_ACR, ACR_PRFTBE);

	/* FLASH ROM2waitɐݒ */
	sil_andw((void*)FLASH_ACR, ~ACR_LATENCY_MASK);
	sil_orw((void*)FLASH_ACR, ACR_LATENCY_TWO);

	/* HCLK = SYSCLK, PCLK2 = HCLK, PCLK1 = HCLK/2  */
	sil_orw((void*)RCC_CFGR, 0x00 | (0x00 << 11) | (0x04 << 8));

	/* PLLCLK = 12MHz x 6 = 72MHz, HSE as PLL clock */
	sil_andw((void*)RCC_CFGR, ~(CFGR_PLL_SRC|CFGR_PLL_XTPRE|CFGR_PLLMUL_MASK));
	sil_orw((void*)RCC_CFGR, CFGR_PLL_SRC | PLLMUL << 18);

	/* PLL̗L */
	sil_orw((void*)RCC_CR, CR_PLL_ON);

	/* PLLL҂ */
	while ((sil_rew_mem((void*)RCC_CR) & CR_PLL_RDY) == 0) ;

	/* PLLVXeNbNɑI */
	sil_andw((void*)RCC_CFGR, ~CFGR_SW_MASK);
	sil_orw((void*)RCC_CFGR, CFGR_SW_PLL);
  
	/* PLL̃VXeNbNI҂ */
	while ((sil_rew_mem((void*)RCC_CFGR) & CFGR_SWS_MASK) != (CFGR_SW_PLL << 2)) ;

	/*
	 *  `bvˑ̏
	 */
	chip_initialize();

	/*
	 *  ytF̗L
	 */
	sil_orw((void*)RCC_APB2ENR, APB2ENR_USART1_EN | APB2ENR_IOPA_EN |
			APB2ENR_IOPD_EN | APB2ENR_AFIO_EN);
#if (TNUM_PORT >= 2)
	sil_orw((void*)RCC_APB2ENR, APB2ENR_IOPD_EN);
	sil_orw((void*)RCC_APB1ENR, APB1ENR_USART2_EN);
#endif
	/*
	 *  I/O|[g̏
	 */
	/* USART1(RX)  vAbv */
	set_cr_mode(GPIOA_BASE, 10, MODE_INPUT);
	set_cr_cnf(GPIOA_BASE, 10, CNF_IN_FLOATING);

	/* USART1(TX) */
	set_cr_mode(GPIOA_BASE, 9, MODE_OUTPUT_50MHZ);
	set_cr_cnf(GPIOA_BASE, 9, CNF_OUT_AF_PP);

#if (TNUM_PORT >= 2)
	/* USART2(RX)  vAbv */
	set_cr_mode(GPIOD_BASE, 6, MODE_INPUT);
	set_cr_cnf(GPIOD_BASE, 6, CNF_IN_FLOATING);

	/* USART2(TX) */
	set_cr_mode(GPIOD_BASE, 5, MODE_OUTPUT_50MHZ);
	set_cr_cnf(GPIOD_BASE, 5, CNF_OUT_AF_PP);

	/* USART2|[g̃}bviPD5,6j */
	sil_orw((void*)AFIO_MAPR, MAPR_USART2_REMAP);
#endif

	/* LED|[g(PD.4) */
	set_cr_mode(GPIOD_BASE, 4, MODE_OUTPUT_50MHZ);
	set_cr_cnf(GPIOD_BASE, 4, CNF_OUT_GP_PP);

	/*
	 *  o[i[o͗p̃VA
	 */
	usart_init(SIO_PORTID);
}


/*
 *  {[hLEDON/OFF
 */
void
stbee_led_on(void){
	sil_andw((void*)(GPIOD_BASE + 0x0c), ~(1 << 4));
}

void
stbee_led_off(void){
	sil_orw((void*)(GPIOD_BASE + 0x0c), (1 << 4));
}

/*
 * ^[Qbgˑ@I
 */
void
target_exit(void)
{
	/* `bvˑ̏I */
	chip_exit();
	while(1);
}

/*
 * VXeO̒჌xo͂̂߂̕o
 */
void
target_fput_log(char_t c)
{
	if (c == '\n') {
		sio_pol_snd_chr('\r', SIO_PORTID);
	}
	sio_pol_snd_chr(c, SIO_PORTID);
}
