#include "bsc.h"
#include "iodefine.h"

void bsc_init(void)
{
	PORT.PCCR0.BIT.PC0MD = 1;	//~CS0
	PORT.PCCR0.BIT.PC1MD = 1;	//~RD
#ifndef BUS_16_BIT_BIG
	PORT.PCCR0.BIT.PC3MD = 1;	//~WE0/~DQML
#else
	PORT.PCCR1.BIT.PC4MD = 1;	//~WE1/~DQMU/~WE
#endif

#ifdef BUS_8_BIT
	PORT.PJCR0.BIT.PJ0MD = 5;	//A0
#endif
	PORT.PBCR0.BIT.PB1MD = 1;	//A1
	PORT.PBCR0.BIT.PB2MD = 1;	//A2
	PORT.PBCR0.BIT.PB3MD = 1;	//A3
	PORT.PBCR1.BIT.PB4MD = 1;	//A4
	PORT.PBCR1.BIT.PB5MD = 1;	//A5
#ifndef BUS_8_BIT
	PORT.PBCR1.BIT.PB6MD = 1;	//A6
#endif

	PORT.PDCR0.WORD = 0x1111;	//D0`D3
	PORT.PDCR1.WORD = 0x1111;	//D4`D7
#ifndef BUS_8_BIT
	PORT.PDCR2.WORD = 0x1111;	//D8`D11
	PORT.PDCR3.WORD = 0x1111;	//D12`D15
#endif

	BSC.CS0BCR.BIT.IWW		= 7;	//Cg-[h^Cg-CgTCNԃAChw
	BSC.CS0BCR.BIT.IWRWD	= 7;	//ʋԃ[h-CgTCNԃAChw
	BSC.CS0BCR.BIT.IWRWS	= 7;	//ԃ[h-CgTCNԃAChw
	BSC.CS0BCR.BIT.IWRRD	= 7;	//ʋԃ[h-[hTCNԃAChw
	BSC.CS0BCR.BIT.IWRRS	= 7;	//ԃ[h-[hTCNԃAChw
	BSC.CS0BCR.BIT.TYPE		= 0;	//ڑʁFʏ
#ifndef BUS_16_BIT_LITTLE
	BSC.CS0BCR.BIT.ENDIAN	= 0;	//GfBAwFrbOGfBAƂē
#else
	BSC.CS0BCR.BIT.ENDIAN	= 1;	//GfBAwFgGfBAƂē
#endif
#ifdef BUS_8_BIT
	BSC.CS0BCR.BIT.BSZ		= 1;	//f[^oXwF8rbg
#else
	BSC.CS0BCR.BIT.BSZ		= 2;	//f[^oXwF16rbg
#endif

	BSC.CS0WCR.NORMAL.BIT.BAS	= 0;	//oCgISRAMoCgANZXI
	BSC.CS0WCR.NORMAL.BIT.SW	= 3;	//AhXC~CS0AT[g~RDC~WEnAT[gxTCN
	BSC.CS0WCR.NORMAL.BIT.WR	= 12;	//ANZXEFCgTCN
	BSC.CS0WCR.NORMAL.BIT.WM	= 1;	//OEFCg}XNwFOEFCg͖
	BSC.CS0WCR.NORMAL.BIT.HW	= 3;	//~RDC~WEnlQ[gAhXC~CS0lQ[gxTCN

	return;
}
